
/*
 * EditPracovnikJDialog.java
 *
 * Created on 21.3.2010, 13:11:37
 */
package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import a0b36pr2_du2.rychly_balik.model.doprava.Riditelny.Opravneni;
import a0b36pr2_du2.rychly_balik.model.personalistika.AdministrativniPracovnik;
import a0b36pr2_du2.rychly_balik.model.personalistika.Pracovnik;
import a0b36pr2_du2.rychly_balik.model.personalistika.VykonnyPracovnik;
import java.util.Collections;
import java.util.List;
import javax.swing.GroupLayout;

/**
 *
 * @author hapallen
 */
public class EditPracovnikJDialog extends EditJdialog {

    private javax.swing.JRadioButton admRadioButton;
    private javax.swing.ButtonGroup typPracovnikaButtonGroup;
    private javax.swing.JRadioButton execRadioButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox opravneniComboBox;
    private javax.swing.JLabel jmenoLabel;
    private javax.swing.JLabel prijmeniLabel;
    private javax.swing.JLabel opravneniLabel;
    private javax.swing.JLabel typPracovnikaLabel;
    private javax.swing.JTextField jmenoTextField;
    private javax.swing.JTextField prijmeniTextField;
    private javax.swing.JButton saveButton;

    public EditPracovnikJDialog(RychlyBalikGui parent, boolean modal, RychlyBalikDataService dataModel) {
        super(parent, modal, dataModel);
    }

    protected void createGui() {
        typPracovnikaButtonGroup = new javax.swing.ButtonGroup();
        jmenoLabel = new javax.swing.JLabel();
        prijmeniLabel = new javax.swing.JLabel();
        opravneniComboBox = new javax.swing.JComboBox();
        opravneniLabel = new javax.swing.JLabel();
        typPracovnikaLabel = new javax.swing.JLabel();
        saveButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        admRadioButton = new javax.swing.JRadioButton();
        execRadioButton = new javax.swing.JRadioButton();
        jmenoTextField = new javax.swing.JTextField();
        prijmeniTextField = new javax.swing.JTextField();

        jmenoLabel.setText("Jméno:");
        prijmeniLabel.setText("Příjmení:");
        opravneniComboBox.setModel(new javax.swing.DefaultComboBoxModel(Opravneni.
                values()));
        opravneniLabel.setText("Oprávnění: ");
        typPracovnikaLabel.setText("Typ pracovníka: ");
        saveButton.setText("Ulož");
        saveButton.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                save(evt);
            }
        });

        cancelButton.setText("Zruš");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel(evt);
            }
        });

        admRadioButton.setText("Administrativní");
        execRadioButton.setText("Výkonný");

        typPracovnikaButtonGroup.add(admRadioButton);
        typPracovnikaButtonGroup.add(execRadioButton);

        //http://www.dil.univ-mrs.fr/~garreta/docJava/tutorial/uiswing/layout/groupExample.html
     GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);

        layout.setAutoCreateGaps(true);
        layout.setAutoCreateContainerGaps(true);

        layout.setVerticalGroup(layout.createSequentialGroup()
            .addGroup(layout.createParallelGroup()
                .addComponent(jmenoLabel)
                .addComponent(jmenoTextField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createParallelGroup()
                .addComponent(prijmeniLabel)
                .addComponent(prijmeniTextField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createParallelGroup()
                .addComponent(typPracovnikaLabel)
                .addComponent(admRadioButton)
                .addComponent(execRadioButton))
            .addGroup(layout.createParallelGroup()
                .addComponent(opravneniLabel)
                .addComponent(opravneniComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createParallelGroup()
                .addComponent(saveButton)
                .addComponent(cancelButton))
        );

        layout.setHorizontalGroup(layout.createParallelGroup()
            .addGroup(layout.createSequentialGroup()
                .addComponent(jmenoLabel)
                .addComponent(jmenoTextField))
            .addGroup(layout.createSequentialGroup()
                .addComponent(prijmeniLabel)
                .addComponent(prijmeniTextField))
            .addGroup(layout.createSequentialGroup()
                .addComponent(typPracovnikaLabel)
                .addComponent(admRadioButton)
                .addComponent(execRadioButton))
            .addGroup(layout.createSequentialGroup()
                .addComponent(opravneniLabel)
                .addComponent(opravneniComboBox))
            .addGroup(layout.createSequentialGroup()
                .addComponent(saveButton)
                .addComponent(cancelButton))
        );

        pack();
    }

    protected void saveToObject(java.awt.event.ActionEvent evt) throws RychlyBalikException {
        Pracovnik p = null;
        if (admRadioButton.isSelected()) {
            p = new AdministrativniPracovnik(jmenoTextField.getText(), prijmeniTextField.
                    getText());
        } else if (execRadioButton.isSelected()) {
            p = new VykonnyPracovnik(jmenoTextField.getText(), prijmeniTextField.
                    getText(), (Opravneni) opravneniComboBox.getSelectedItem());
        } else {
            throw new RychlyBalikException("Je treba zvolit typ pracovnika");
        }
        dataModel.pridejPracovnika(p);
        parentGui.aktualizujPracovniciGui();
        //parentGui.aktualizujGui();
    }
}
